#include <Arduino.h>

#define PIN_CLK PC5
#define PIN_CS PC4
#define PIN_DIN PC6

const uint8_t char_table[38][8]={
{0x0,0x41,0x22,0x14,0x8,0x14,0x22,0x41},//X
//{0x3C,0x42,0x42,0x42,0x42,0x42,0x42,0x3C},//0
{0x10,0x30,0x50,0x10,0x10,0x10,0x10,0x7c},//1
{0x7E,0x2,0x2,0x7E,0x40,0x40,0x40,0x7E},//2
{0x3E,0x2,0x2,0x3E,0x2,0x2,0x3E,0x0},//3
{0x8,0x18,0x28,0x48,0xFE,0x8,0x8,0x8},//4
{0x3C,0x20,0x20,0x3C,0x4,0x4,0x3C,0x0},//5
{0x3C,0x20,0x20,0x3C,0x24,0x24,0x3C,0x0},//6
{0x3E,0x22,0x4,0x8,0x8,0x8,0x8,0x8},//7
{0x0,0x3E,0x22,0x22,0x3E,0x22,0x22,0x3E},//8
{0x3E,0x22,0x22,0x3E,0x2,0x2,0x2,0x3E},//9
{0x18,0x24,0x42,0x42,0x7E,0x42,0x42,0x42},//A
{0x3C,0x22,0x22,0x3c,0x22,0x22,0x3C,0x0},//B
{0x3C,0x40,0x40,0x40,0x40,0x40,0x40,0x3C},//C
{0x7C,0x22,0x22,0x22,0x22,0x22,0x22,0x7C},//D
{0x7C,0x40,0x40,0x7C,0x40,0x40,0x40,0x7C},//E
{0x7C,0x40,0x40,0x7C,0x40,0x40,0x40,0x40},//F
{0x3C,0x40,0x40,0x40,0x4c,0x44,0x44,0x3C},//G
{0x44,0x44,0x44,0x7C,0x44,0x44,0x44,0x44},//H
{0x7C,0x10,0x10,0x10,0x10,0x10,0x10,0x7C},//I
{0x3C,0x8,0x8,0x8,0x8,0x8,0x48,0x30},//J
{0x0,0x24,0x28,0x30,0x20,0x30,0x28,0x24},//K
{0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x7C},//L
{0x81,0xC3,0xA5,0x99,0x81,0x81,0x81,0x81},//M
{0x0,0x42,0x62,0x52,0x4A,0x46,0x42,0x0},//N
{0x3C,0x42,0x42,0x42,0x42,0x42,0x42,0x3C},//O
{0x3C,0x22,0x22,0x22,0x3C,0x20,0x20,0x20},//P
{0x1C,0x22,0x22,0x22,0x22,0x26,0x22,0x1D},//Q
{0x3C,0x22,0x22,0x22,0x3C,0x24,0x22,0x21},//R
{0x0,0x1E,0x20,0x20,0x3E,0x2,0x2,0x3C},//S
{0x0,0x3E,0x8,0x8,0x8,0x8,0x8,0x8},//T
{0x42,0x42,0x42,0x42,0x42,0x42,0x22,0x1C},//U
{0x42,0x42,0x42,0x42,0x42,0x42,0x24,0x18},//V
{0x0,0x49,0x49,0x49,0x49,0x2A,0x1C,0x0},//W
{0x0,0x41,0x22,0x14,0x8,0x14,0x22,0x41},//X
{0x41,0x22,0x14,0x8,0x8,0x8,0x8,0x8},//Y
{0x0,0x7F,0x2,0x4,0x8,0x10,0x20,0x7F},//Z
};

void write_byte (uint8_t byte)
{
  for (uint8_t i =0; i<8; i++)
  {
    digitalWrite(PIN_CLK, LOW);
    digitalWrite(PIN_DIN, byte&0x80);
    byte = byte<<1;
    digitalWrite(PIN_CLK, HIGH);
  }
}

void write_max (uint8_t address, uint8_t data)
{
  digitalWrite(PIN_CS, LOW);
  write_byte(address);
  write_byte(data);
  digitalWrite(PIN_CS, HIGH);
}

void max_init(void)
{
  write_max(0x09, 0x00);       //  no decoding
  write_max(0x0a, 0x00);       //  brightness intensity
  write_max(0x0b, 0x07);       //  scan limit = 8 LEDs
  write_max(0x0c, 0x01);       //  power down =0,normal mode = 1
  write_max(0x0f, 0x00);       //  no test display
}

void display_fill(uint8_t data) 
{
  for(uint8_t i = 0; i < 8; i++)
  {                                              
    write_max(i+1, data);
    delay(50);
  }
  delay(500);
}

void setup() 
{
  pinMode(LED_BUILTIN, OUTPUT);

  digitalWrite(PIN_CLK, LOW);
  digitalWrite(PIN_CS, LOW);
  digitalWrite(PIN_DIN, LOW);
  
  pinMode(PIN_CLK, OUTPUT);
  pinMode(PIN_CS, OUTPUT);
  pinMode(PIN_DIN, OUTPUT);

  max_init();
  display_fill(0x00);
  display_fill(0xff);
  display_fill(0x00);
}

void loop() 
{
  for (uint8_t j=0; j<38; j++)
  {
    digitalWrite(LED_BUILTIN, HIGH);
    delay(200);
    
    for (uint8_t i=1; i<9; i++)
    {
      write_max (i, char_table[j][i-1]);
    }
    delay(1000);

    display_fill(0x00);

    digitalWrite(LED_BUILTIN, LOW);
    delay(200);
  }
}
